/**********************************************************
 * TEST PCA9634 LED8 PWM_Expander ADR=61
 **********************************************************/

#include <Wire.h> 
#define adr 0x61 //A6,5,0=VCC, reszta GND

void setup() 
{ 
  byte data[19]={
    0x80, // Autoinkrementacja adresu
    0x80,0x14, // MODE1/2 bez subadresow, grupowe sciemnianie, opendrain, inversja
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //PWMx = off
    0x80,0x40, //PWM 50%, BLINK 1.8s
    0xAA,0xAA, //LEDOUTx indywidualny PWMx
    0xE2,0xE4,0xE8,0xE0      }; // domyślne podadresy globalne

  Wire.begin();        // inicjacja I2C
  delay(1);
  Wire.beginTransmission(adr);
  Wire.write(data, 19); // konfiguracja PCA
  Wire.endTransmission();
} 

void loop() 
{ 
  Wire.beginTransmission(adr);
  Wire.write(0x00);
  Wire.write(0b00000000); // MODE1
  Wire.endTransmission();

  Wire.beginTransmission(adr);
  Wire.write(0x01);
  Wire.write(0b00011100); // MODE2, dim
  Wire.endTransmission();

  //PWM indywidualny LEDx=PWMx
  for (int y=2; y<10;y++) //PWM0..7 min->max
    for (int x=0; x<0xFF; x++)
    {
      {
        Wire.beginTransmission(adr);
        Wire.write(y); 
        Wire.write(x);
        Wire.endTransmission();
        delay(5);
      }
    }

  // PWM globalny GRPPWM max..min
  Wire.beginTransmission(adr);
  Wire.write(0x01);
  Wire.write(0b00011100); // MODE2
  Wire.endTransmission();

  Wire.beginTransmission(adr);
  Wire.write(0x0C);
  Wire.write(0b11111111); // LEDOUT0, global dim/pwm
  Wire.endTransmission();

  Wire.beginTransmission(adr);
  Wire.write(0x0D);
  Wire.write(0b11111111); // LEDOUT1, global dim/pwm
  Wire.endTransmission();

  for (int x=0xFF; x>0; x--) //GRPPWM min->max
  {
    Wire.beginTransmission(adr);
    Wire.write(0x0A); 
    Wire.write(x); //GRPWM
    Wire.endTransmission();
    delay(20);

  }

  // Globalne miganie 1s/50% wypełnienia
  Wire.beginTransmission(adr);
  Wire.write(0x01);
  Wire.write(0b00111100); // MODE2, blink
  Wire.endTransmission();

  Wire.beginTransmission(adr);
  Wire.write(0x0A); 
  Wire.write(0x80); //GRPWM % wypełnienia BLINK
  Wire.endTransmission();

  Wire.beginTransmission(adr);
  Wire.write(0x0B);
  Wire.write(0b00100000); // GRPFREQ = 1s
  Wire.endTransmission();

  while(1);    

} 








