# Imports
import webiopi

# Enable debug output
webiopi.setDebug()

# Retrieve GPIO lib
GPIO = webiopi.GPIO
DI1 = 17
DI2 = 18
DI3 = 27
DI4 = 22
REL1 = 24
REL2 = 25

# Called by WebIOPi at script loading
def setup():
    # Setup GPIOs
    GPIO.setFunction(DI1, GPIO.IN)
    GPIO.setFunction(DI2, GPIO.IN)
    GPIO.setFunction(DI3, GPIO.IN)
    GPIO.setFunction(DI4, GPIO.IN)
    GPIO.setFunction(REL1, GPIO.OUT)
    GPIO.setFunction(REL2, GPIO.OUT)
    
while True:
    # Reading input     
    DI1value = GPIO.digitalRead(DI1)
    DI2value = GPIO.digitalRead(DI2)
    DI3value = GPIO.digitalRead(DI3)
    DI4value = GPIO.digitalRead(DI4)
    # Show value    
    print("DI1: " +str(DI1value)+" DI2: " +str(DI2value)+" DI3: " +str(DI3value)+" DI4: " +str(DI4value))

    # D1/2, D3/4 set/reset RL1/2   
    if (DI1value == True):
         GPIO.digitalWrite(REL1, GPIO.HIGH)
         print("REL1: ON ")
    if (DI2value == True):
         GPIO.digitalWrite(REL1, GPIO.LOW)
         print("REL1: OFF ")
    if (DI3value == True):
         GPIO.digitalWrite(REL2, GPIO.HIGH)
         print("REL2: ON ")
    if (DI4value == True):
         GPIO.digitalWrite(REL2, GPIO.LOW)
         print("REL2: OFF ")
    webiopi.sleep(2)

def destroy():
    webiopi.debug("RELAY GPIO restore")
    # Reset GPIO functions
    GPIO.setFunction(DI1, GPIO.IN)
    GPIO.setFunction(DI2, GPIO.IN)
    GPIO.setFunction(DI3, GPIO.IN)
    GPIO.setFunction(DI4, GPIO.IN)
    GPIO.setFunction(REL1, GPIO.IN)
    GPIO.setFunction(REL2, GPIO.IN)

